from math import sqrt
from ..group import NonAbelianGroup

### A4 #################################################################################################################

A4_reps = ['1', '1p', '1pp', '3']

A4_tensor_products = [[['1'], ['1p'], ['1pp'], ['3']],
                      [['1p'], ['1pp'], ['1'], ['3']],
                      [['1pp'], ['1'], ['1p'], ['3']],
                      [['3'], ['3'], ['3'], ['1', '1p', '1pp', '3', '3']]]

A4_clebsches = {'1 x 1': [[1]],
                '1 x 1p': [[1]],
                '1 x 1pp': [[1]],
                '1p x 1p': [[1]],
                '1p x 1pp': [[1]],
                '1pp x 1pp': [[1]],
                '1 x 3': [[1,0,0],[0,1,0],[0,0,1]],
                '1p x 3': [[1,0,0],[0,1,0],[0,0,1]],
                '1pp x 3': [[1,0,0],[0,1,0],[0,0,1]],
                '3 x 3': [[1,0,0, 0,0,1, 0,1,0],
                          [0,1,0, 1,0,0, 0,0,1],
                          [0,0,1, 0,1,0, 1,0,0],
                          [i * 1/sqrt(3) for i in [2,0,0, 0,0,-1, 0,-1,0]],
                          [i * 1/sqrt(3) for i in [0,-1,0, -1,0,0, 0,0,2]],
                          [i * 1/sqrt(3) for i in [0,0,-1, 0,2,0, -1,0,0]],
                          [0,0,0, 0,0,1, 0,-1,0],
                          [0,1,0, -1,0,0, 0,0,0],
                          [0,0,-1, 0,0,0, 1,0,0]]}

A4_clebsches = {'1 x 1': {'1': [[[1]]]},
                '1 x 1p': {'1p': [[[1]]]},
                '1 x 1pp': {'1pp': [[[1]]]},
                '1p x 1p': {'1pp': [[[1]]]},
                '1p x 1pp': {'1': [[[1]]]},
                '1pp x 1pp': {'1p': [[[1]]]},
                '1 x 3': {'3': [[[1,0,0],[0,1,0],[0,0,1]]]},
                '1p x 3': {'3': [[[1,0,0],[0,1,0],[0,0,1]]]},
                '1pp x 3': {'3': [[[1,0,0],[0,1,0],[0,0,1]]]},
                '3 x 3': {'1': [[[1,0,0, 0,0,1, 0,1,0]]],
                          '1p': [[[0,1,0, 1,0,0, 0,0,1]]],
                          '1pp': [[[0,0,1, 0,1,0, 1,0,0]]],
                          '3': [[[" 2/sqrt(3)",0,0, 0,0,"- 1/sqrt(3)", 0,"- 1/sqrt(3)",0],
                                 [0,"- 1/sqrt(3)",0, "- 1/sqrt(3)",0,0, 0,0," 2/sqrt(3)"],
                                 [0,0,"- 1/sqrt(3)", 0," 2/sqrt(3)",0, "- 1/sqrt(3)",0,0]],
                                [[0,0,0, 0,0,1, 0,-1,0],
                                 [0,1,0, -1,0,0, 0,0,0],
                                 [0,0,-1, 0,0,0, 1,0,0]]]}}

A4 = NonAbelianGroup('A4', gapid=[12, 3], representations=A4_reps,
                     tensor_products=A4_tensor_products, clebsches=A4_clebsches)
